#include"definitions.h"
#include"hammack_edgN_Nstar.h"

#include "decompose_strong/print_stuff.h"
#include "decompose_strong/init_stuff.h"
#include "decompose_strong/decompose.h"

#include <vector> 
#include <boost/graph/graph_utility.hpp>

using namespace std;
using namespace boost; 

void init_edge_neigborhhood(set<int>& N1, set<int>& N2,set<int>& edgeN){

	edgeN.clear();
	set_union(N1.begin(), N1.end(),
    		  N2.begin(), N2.end(),
		      inserter(edgeN, edgeN.begin()));

}


bool condition1(set<int>& N1, set<int>& N2,set<int>& z_Set, int x, int y, vector< set<int> >& N){
	
	set<int> inters_Nxy;
	init_intersection(N1,N2,inters_Nxy);
	
	set<int>::iterator si;
	for(si=z_Set.begin();si!=z_Set.end();si++){
		if(*si!=x && *si!=y){
			
			set<int> inters_Nxz;
			set<int> inters_Nyz;
			init_intersection(N1,N[*si],inters_Nxz);
			init_intersection(N2,N[*si],inters_Nyz);
			

			if(is_proper_subset(inters_Nxy,inters_Nxz) && is_proper_subset(inters_Nxy,inters_Nyz)){
				//cout << endl << "N" << *si << "="; 
				//showSet(N[*si]);
	
				return true;
			}
		}
	}
	 
	return false;
} 

bool condition2(set<int>& N1, set<int>& N2,set<int>& z_Set, int x, int y, vector< set<int> >& N){
	
	set<int> N_A,N_B;/**N_A \proper subset of N_B*/
	N_A.clear();N_B.clear();
	if(is_proper_subset(N1,N2)){
		N_A = N1;
		N_B = N2;
	}
	else if(is_proper_subset(N2,N1)){
		N_A = N2;
		N_B = N1;
	}
	else return false;
	
	set<int>::iterator si;
	for(si=z_Set.begin();si!=z_Set.end();si++){
		if(*si!=x && *si!=y){
		
			if(is_proper_subset(N_A,N[*si]) && is_proper_subset(N[*si],N_B)){
				//cout << endl << "N" << *si << "="; 
				//showSet(N[*si]);
			
				return true;
			}
		}
	
	}
	
	return false;
}

void HammackApproach(myGraph& G, eD edge, vector< set<int> >& N){
	
	//int v_t = target(*ei, CartSk);
	int x = target(edge, G);
	int y = source(edge,G);
	/*cout << endl << "N" << x << "="; 
	showSet(N[x]);
	cout << endl << "N" << y << "="; 
	showSet(N[y]);
	*/
	set<int> edgeN; 
	init_edge_neigborhhood(N[x], N[y],edgeN);
	
	/*cout << endl << "edgeN = " ;
	showSet(edgeN);
	*/
	
	myEdgeW weightG = get(edge_weight, G);
	
	/**exists z \in edgeN s.t. N[x] \intersection N[y] is proper subset of N[x] \intersection N[z] 
				         and N[x] \intersection N[y] is proper subset of N[y] \intersection N[z] */
	if(condition1(N[x],N[y],edgeN, x,y, N)){
		/*cout << endl << "N" << x << "="; 
		showSet(N[x]);
		cout << endl << "N" << y << "="; 
		showSet(N[y]);
		cout << endl << "\t\t\t" << x << " - " << y <<" 1markNonCartesian";*/
		put(weightG, edge, 0); 
	}
	/**exists z in edgeN s.t. N_x \proper_subset N_z \proper_subset N_y
					or  N_y \proper_subset N_z \proper_subset N_x*/
	else if(condition2(N[x],N[y],edgeN, x,y, N)){
		/*cout << endl << "N" << x << "="; 
		showSet(N[x]);
		cout << endl << "N" << y << "="; 
		showSet(N[y]);
		cout << endl << "\t\t\t" << x << " - " << y <<" 2markNonCartesian";*/
		put(weightG, edge, 0); 
	}
	else{ 
		//cout << endl << edge <<" marked as Cartesian ";
		put(weightG, edge, 1); 
	}
	/**else if is product  - -- marK cart*/
	/**else if not a product  - -- nonCart*/
	
}





bool condition2_onEdgeN(set<int>& N1, set<int>& N2,set<int>& z_Set, int x, int y, vector< set<int> >& N){
	
	set<int> N_A,N_B;/**N_A \proper subset of N_B*/
	N_A.clear();N_B.clear();
	if(is_proper_subset(N1,N2)){
		N_A = N1;
		N_B = N2;
	}
	else if(is_proper_subset(N2,N1)){
		N_A = N2;
		N_B = N1;
	}
	else return false;
	

	set<int>::iterator si;
	for(si=z_Set.begin();si!=z_Set.end();si++){
		if(*si!=x && *si!=y){
			
			set<int> inters_Nz_edgeN;
			//set<int> inters_Nyz;
			//init_intersection(N1,N[*si],inters_Nxz);
			init_intersection(z_Set,N[*si],inters_Nz_edgeN);
			
//			cout << endl << "N" << *si << "="; 
//			showSet(inters_Nz_edgeN);			

//			cout << endl << "in union N" << *si << "="; 
//			showSet(inters_Nz_edgeN);
			
			if(is_proper_subset(N_A,inters_Nz_edgeN) && is_proper_subset(inters_Nz_edgeN,N_B)){
				//cout << endl << "cond2 for (" << x << "," << y << ") found z = "  << *si;
				//cout << endl << "N" << *si << "="; 
				showSet(N[*si]);
			
				return true;
			}
		}
	
	}
	
	return false;
}



bool HammackApproach_on_EdgeN(myGraph& G, eD edge, int x, int y, vector< set<int> >& N, set<int>& edgeN){
	
	//myEdgeW weightG = get(edge_weight, G);
	
	/**exists z \in edgeN s.t. N[x] \intersection N[y] is proper subset of N[x] \intersection N[z] 
				         and N[x] \intersection N[y] is proper subset of N[y] \intersection N[z] */
	if(condition1(N[x],N[y],edgeN, x,y, N)){
		//put(weightG, edge, 0); 
		return false;
	}
	/**exists z in edgeN s.t. N_x \proper_subset N_z \proper_subset N_y
					or  N_y \proper_subset N_z \proper_subset N_x*/
	else if(condition2_onEdgeN(N[x],N[y],edgeN, x,y, N)){
		//put(weightG, edge, 0); 
		return false;
	}
	else{ 
		//put(weightG, edge, 1); 
		return true;
	}
	/**else if is product  - -- marK cart*/
	/**else if not a product  - -- nonCart*/
	
	
}


bool checkDispens_in_edgeN_and_PFD
	(vector< set<int> > N, int x, int y, myGraph& G, vector< vector<int> >& all_colors_of_edge,myGraph& ColorGraph){
		
	
	eD this_edge = edge(x,y,G).first;
	set<int> edgeN;
	init_edge_neigborhhood(N[x], N[y],edgeN);
	
	/*cout << endl << "edgeN " << x << " = ";
	showSet(N[x]);
	cout << endl << "edgeN " << y << " = ";
	showSet(N[y]);

	cout << endl << "edgeN " << x << " and " << y << "=" ;
	showSet(edgeN);
	cout << endl;*/
	
	bool non_dispensable = HammackApproach_on_EdgeN(G, this_edge, x,y, N, edgeN);
	
	vector<int> V_ID;
	
		VecOfSets S; S.clear();
		myGraph local_CartRelGraph; /**edges of CartSk(N) to vertices, and connected if in same product-class*/
		myGraph local_CartSk, local_CartSk_eID; /**local_CartSk has edgeID 0, ..., num_edges(CartSk) 
														local_CartSk_eID has same edgeID as N*/

	//myEdgeW weightG = get(edge_weight, G);
	if(non_dispensable){ /*hence if this_edge is Cart*/
		myGraph induced_edgeN;
	//	cout << endl << " check  egdeN of " << x << " and " << y;
	//	cout << endl << " now PFD of edgeN";
		init_induced_H(G, N,  induced_edgeN,  edgeN, V_ID);
				


		//print_graph(induced_edgeN);

		
		myGraph thin_edgeN;
		
		int CASE = decompose( induced_edgeN, local_CartSk, local_CartSk_eID, local_CartRelGraph, thin_edgeN, S, V_ID);
		bool dummy=true;
		if(CASE!=2){
			cout << endl << "edgeN " << x << " - "<< y << " nonprime 	";
			stepwise_CartesianEdges_and_Colorgraph(G, local_CartSk, local_CartRelGraph, induced_edgeN, thin_edgeN, 
													S,	V_ID,  ColorGraph, all_colors_of_edge, dummy);
		}
		else cout << endl << "edgeN " << x << " - "<< y << " prime, hence not used.";
			/**dies in if-befingung also nur nonprime regions, for approximate stuff!!!*/
			/*stepwise_CartesianEdges_and_Colorgraph(G, local_CartSk, local_CartRelGraph, induced_edgeN, thin_edgeN, 
													S,	V_ID,  ColorGraph, all_colors_of_edge, dummy);*/

		//print_local_Factors(local_CartSk, local_CartRelGraph);
		
		return true;
	}


		return false;
}



void PFD_N_star
	(vector< set<int> > N, int x, int y, myGraph& G, vector< vector<int> >& all_colors_of_edge,myGraph& ColorGraph){
		
	//eD this_edge = edge(x,y,G).first;
	set<int> edgeN;
	init_edge_neigborhhood(N[x], N[y],edgeN);
	
//	bool non_dispensable = HammackApproach_on_EdgeN(G, this_edge, x,y, N, edgeN);
	
	vector<int> V_ID;
	
	VecOfSets S; S.clear();
	myGraph local_CartRelGraph; /**edges of CartSk(N) to vertices, and connected if in same product-class*/
	myGraph local_CartSk, local_CartSk_eID; /**local_CartSk has edgeID 0, ..., num_edges(CartSk) 
														local_CartSk_eID has same edgeID as N*/

	//myEdgeW weightG = get(edge_weight, G);
	//cout  << endl << "check N*";
	set<int> intersN;
	init_intersection(N[x], N[y], intersN);
	set<int>::iterator set_it;
	set<int> union_over_all;
	for (set_it=intersN.begin();set_it!=intersN.end();++set_it)
		init_union_all(union_over_all, N[*set_it],union_over_all);
		
	myGraph induced_H;
	init_induced_H(G, N,  induced_H, union_over_all, V_ID);
	myGraph thin_H;

	/*int CASE =*/ decompose(induced_H, local_CartSk, local_CartSk_eID, local_CartRelGraph, thin_H, S, V_ID);
	bool dummy=true;
	//if(CASE!=2){
	//	cout << endl << "N* " << x << " - "<< y << " nonprime	";
		stepwise_CartesianEdges_and_Colorgraph(G, local_CartSk, local_CartRelGraph, induced_H, thin_H, 
											   S, V_ID, ColorGraph, all_colors_of_edge, dummy);
	//}
	//else cout << endl << "N* " << x << " - "<< y << " prime	";
}





